package com.bwie.aop;

import com.bwie.utils.HttpServletRequestReader;
import lombok.extern.log4j.Log4j2;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.ServletOutputStream;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.HashSet;
import java.util.Set;

@Log4j2
@Aspect
@Component
public class RepeatSubmit {

    private final ThreadLocal<String> threadLocal=new ThreadLocal<>();

    @Pointcut("@annotation(com.bwie.aop.RepeatEnum)")
    private void pointcut(){}

    @Autowired
    private HttpServletRequest request;

    private final Set<String> set=new HashSet<>();

    private static final String apiTemplate="%s:%s:%s";

    @Autowired
    private HttpServletResponse response;


    @Before("pointcut()")
    public void bef() {
        log.info("切面  -前");
        String token = request.getHeader("token");
        String body = HttpServletRequestReader.ReadAsChars(request);
        String format = String.format(apiTemplate, token, request.getRequestURI(), body);
        threadLocal.set(format);
        log.info("提交唯一标识：{}", format);
        //用户+请求+内容
            if (set.contains(format)) {
                resp(response,"重复提交");
            }
            set.add(format);
    }



    @After("pointcut()")
    public void aft(){
        log.info("切面  -后");
            set.remove(threadLocal.get());
            threadLocal.remove();
    }


    //相应方法封装
    private void resp(ServletResponse servletResponse, String msg){
        try {
            HttpServletResponse response=(HttpServletResponse) servletResponse;
            ServletOutputStream outputStream = response.getOutputStream();
            response.setStatus(401);
            response.setContentType("application/json");
            outputStream.write(msg.getBytes(StandardCharsets.UTF_8));
        } catch (IOException e) {
            e.printStackTrace();
        }

    }
}
