package com.bwie.config;

import com.bwie.Filter.TokenFilter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.web.servlet.FilterRegistrationBean;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;

import javax.servlet.Filter;

//@Configuration
public class WebMvcConfig implements WebMvcConfigurer {

    @Autowired
    private TokenFilter tokenFilter;


    /**
    * 登录过滤器
	* 如果这个没有配置的话，默认所有的请求都会走filter
    */
    @Bean
    public FilterRegistrationBean<Filter> loginFilterRegistration(){
        FilterRegistrationBean<Filter> registrationBean = new FilterRegistrationBean<>();
        //设置过滤器
        registrationBean.setFilter(tokenFilter);
        registrationBean.setName("loginFilter");
        //拦截路径,这个就不大好，每次新增接口都得添加新的拦截器
        registrationBean.addUrlPatterns("/test/get");
        //指定顺序，数字越小越靠前
        registrationBean.setOrder(-1);
        return registrationBean;
    }



}

